	ORG $1001-2
	DW  $1001
	
	DB $0B,$10,0,0
	DB 0,0,0,0,0
	DB 0,0,0

beg_	= $0800
end_	= $0FE8
dest	= $2FFF
flags	= $1800

ptr	= $D0		; pointers
dst	= $D2

flag	= $E0		; vars
curr	= $E1
len	= $E2
	
start
	SEI
	STA $FF3F
	;
	LDA #$51
	STA $FF19
	;
	; --- clear flag area
	LDY #$00
	TYA
cl1	STA flags,y
	INY 
	BNE cl1 
	;
	LDA #beg_ & 255
	STA ptr
	LDA #beg_ >> 8
	STA ptr+1
	;
	LDY #$00		; make byte before first diff.
	LDA (ptr),y
	PHA
	JSR dec_ptr
	PLA
	EOR #$55
	STA (ptr),y
	JSR inc_ptr
	;
	; ---
l1	LDY #$00
	LDA (ptr),y		; get one byte
	TAX
	LDA #$FF
	STA flags,x		; flag each used byte
	;
	JSR inc_ptr
	;
	LDA ptr			; at the end?
	CMP #end_ & 255
	BNE l1
	LDA ptr+1
	CMP #end_ >> 8
	BNE l1
	;
	; ---
	;
	LDY #$00		; find first unused byte
l2	LDA flags,y
	BPL found
	INY
	BNE l2	
	;
	LDA #$32	; no flag
	STA $FF19
	JMP *
	
found	TYA			; found the flag, store it
	STA flag
	;
	; --- start compression
	;
	LDA #dest & 255		; start storing data from here
	STA dst
	LDA #dest >> 8
	STA dst+1
	;
	LDA #end_ & 255		; start comparing from end...
	STA ptr
	LDA #end_ >> 8
	STA ptr+1
	;
	JSR dec_ptr		; non-inclusive, so back 1 byte
	;
loop_beg
	LDA ptr			; reached beg?
	CMP #(beg_-1) & 255
	BNE b1
	LDA ptr+1
	CMP #(beg_-1) >> 8
	BNE b1
	;
	LDA #$45		; happy end
	STA $FF19
	JMP *
	
b1	LDA #$00		; reset length each time
	STA len
	;
	LDY #$00
	LDA (ptr),y
	STA curr		; get current byte
	;
	JSR dec_ptr
	;
	LDA curr
	CMP (ptr),y		; same as prev?
	BNE diff
	;
	; ---
count_length
	INC len
	;
	JSR dec_ptr
	LDA curr
	CMP (ptr),y		; keep going back
	BEQ count_length
	;
	LDA flag
	JSR store
	LDA len
	JSR store
	LDA curr
	JSR store
	;
	JMP loop_beg
	;
diff	LDA curr		; different byte
	JSR store
	;
	JMP loop_beg
	
inc_ptr
	LDA ptr
	CLC
	ADC #$01
	STA ptr
	BCC *+4
	INC ptr+1
	RTS
	
dec_ptr
	LDA ptr
	SEC
	SBC #$01
	STA ptr
	LDA ptr+1
	SBC #$00
	STA ptr+1
	RTS  
	
store
	LDY #$00
	STA (dst),y
	JSR dec_dst 
	RTS
dec_dst
	LDA dst
	SEC
	SBC #$01
	STA dst
	LDA dst+1
	SBC #$00
	STA dst+1
	RTS
;[eof]