	ORG $1001-2
	DW  $1001
	
	include "!playerv.asm"
	
	DW nextln,0	; second word is line number
	DB $9E
	IF start > 9999
	DB "0"+start/10000
	ENDIF
	DB "0"+(start/1000)%10,"0"+(start/100)%10,"0"+(start/10)%10,"0"+start%10,0
nextln	DB 0,0

code_dest	= $F480
code_dest_ptr	= $E0
scr_dest	= $E2
copy_dest	= $E5

text_data_ptr	= $C0	; 16 bit
text_ptr	= $C2	; 16 bit
text_counter	= $C4	; 8 bit
text_length	= $C5	; 8 bit
text_invert	= $C6	; 8 bit

print_src	= $B0	; 16 bit
print_dst	= $B2	; 16 bit
print_col	= $B4	; 16 bit

timer		= $EE
status		= $EF
	
start
	SEI
	;
	LDY #$FF	; push cursor to invisible area 
	STY $FF0C
	STY $FF0D
	;
	JSR hide
	;
	;JSR $ff81	; some rom calling, like reset to standard
	;JSR $ff84
	;JSR $ff8a
	;
	STA $FF3F
	;
	LDY #$00
	STY status
	STY timer
	STY text_counter
	LDA #$80
	STA text_invert
	;
	LDA #text_data & 255
	STA text_data_ptr
	LDA #text_data >> 8
	STA text_data_ptr+1
	;
	LDA #(code_dest & 255)
	STA code_dest_ptr
	LDA #(code_dest >> 8)
	STA code_dest_ptr+1
	;
	LDA #$12		; destination position for the star: $0C12
	STA scr_dest
	LDA #$0C
	STA scr_dest+1
	;
loop1	LDA scr_data,y
	BEQ done
	TAX
	TYA
	PHA
	;
cc1	JSR copy_chunk
	DEX
	BPL cc1
	;
	PLA
	CMP #$38
	BNE cc2
	;
	PHA
	LDA #$E6		; INC $D1 opcode
	JSR put_byte
	LDA #$D1
	JSR put_byte
	PLA
	;
cc2	TAY
	INY
	LDA scr_data,y
	JSR inc_scr_dest
	;
	INY
	BNE loop1
done	;
	LDY #$00
	LDA #$60		; RTS opcode
	JSR put_byte
	;
	; ---
	;
	LDA #$C4
	STA $FF12
	LDA #$D1
	STA $FF13
	;
	LDA #$1B
	STA $FF06
	;
	JSR PLAYER_FREQ_INIT
	;
	JSR set_irq1
	;
	LDA $FF07
	AND #$40
	ORA #$08
	STA $FF07
	;
	CLI
	;
main	JMP main1
main1	LDA timer
	JMP main
 
	include "hide.asm" 
	include "unpack.asm"
 
lolcat_unpack
	LDA #$02
	LDX #(lolcat_packed_end-1) & 255
	LDY #(lolcat_packed_end-1) >> 8
do_unpack
	STA flag+1
	JSR unpack
	;
restore_main
	LDA #main1 & 255
	STA main+1
	LDA #main1 >> 8
	STA main+2
	;
	JSR next_status
	;
	JMP main
	
yo_dawg_unpack
	LDA #$02
	LDX #(yo_dawg_packed_end-1) & 255
	LDY #(yo_dawg_packed_end-1) >> 8
	JMP do_unpack
	
yuno_unpack
	LDA #$01
	LDX #(yuno_packed_end-1) & 255
	LDY #(yuno_packed_end-1) >> 8
	JMP do_unpack
	
the_end_unpack
	LDA #$06
	LDX #(the_end_packed_end-1) & 255
	LDY #(the_end_packed_end-1) >> 8
	JMP do_unpack
	
hat_unpack
	LDA #$D2		; self-mod to: LDY #$D2 / JMP $F96C
	STA star_call+1
	LDA #$6C
	STA star_call+3
	LDA #$F9
	STA star_call+4
	;
	LDA #$02
	LDX #(hat_packed_end-1) & 255
	LDY #(hat_packed_end-1) >> 8
	;
	STA flag+1
	JSR unpack
	;
	JSR animate_star_hat
	;
	JMP restore_main
	
prepare_star
	LDX #$00
ps1	LDA #$00
	STA $0C00,X
	STA $0D00,X
	STA $0E00,X
	STA $0F00,X
	LDA #$51
	STA $0800,X
	STA $0900,X
	STA $0A00,X
	STA $0B00,X
	INX
	BNE ps1
	;
	LDA #$01
	;
	LDX #$05
c1	STA $0D29,X
	STA $0EB9,x
	DEX
	BPL c1
	;
	LDX #$07
c2	STA $0D50,X
	STA $0E90,x
	DEX
	BPL c2
	;
	LDX #$09
c3	STA $0D77,X
	STA $0E67,x
	DEX
	BPL c3
	;
	LDX #$0B
c4	STA $0D9E,X
	STA $0D9E+40,X
	STA $0D9E+80,X
	STA $0D9E+120,X
	STA $0D9E+160,X
	DEX
	BPL c4
	;
	JSR animate_star
	;
	JMP restore_main
	
copy_chunk
	LDY #$00
	LDA #$B1	; LDA ($D0),y opcode
	JSR put_byte
	LDA #$D0
	JSR put_byte
	;
	LDA #$8D	; STA $0000 opcode
	JSR put_byte
	LDA scr_dest
	JSR put_byte
	LDA scr_dest+1
	JSR put_byte
	;
	LDA #$01
	JSR inc_scr_dest
	;
	LDA #$C8	; iny
put_byte
	STA (code_dest_ptr),y
	;
	LDA code_dest_ptr
	CLC
	ADC #$01
	STA code_dest_ptr
	BCC *+4
	INC code_dest_ptr+1
	RTS
	
inc_scr_dest
	CLC
	ADC scr_dest
	STA scr_dest
	BCC *+4
	INC scr_dest+1
	RTS
	
;sta_skip
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	;
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	;
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	;
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	;
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,6,6,0
;	DB 5,6,6,0, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8, 5,8,5,8

copy_split_value
	LDX timer
	CPX #$C8
	BNE csv_1
	;
	JMP next_status
	
csv_1	CPX #$00
	BNE csv_2
	;
	LDA #(raster_last_line) & 255
	STA copy_dest
	LDA #(raster_last_line) >> 8
	STA copy_dest+1
	;
csv_2	INC timer
	;
	LDY #$0A
	LDA (copy_dest),y
	CMP #$EA		; badline
	BEQ csv_badline
	;
	LDA raster_mid_left,x
	LDY #$01
	STA (copy_dest),y
	;
	LDA raster_left,x
	LDY #$06
	STA (copy_dest),y
	;
	LDA raster_right,x
	LDY #$0E
	STA (copy_dest),y
	;
	LDA raster_mid_right,x
	LDY #$13
	STA (copy_dest),y
	;
	LDA #$8D		; STA $0000 opcode
	LDY #$14
	STA (copy_dest),y
	;	
	JMP goto_prev_line
	
csv_badline
	LDA raster_mid_left,x
	LDY #$01
	STA (copy_dest),y
	;
	LDA raster_left,x
	LDY #$06
	STA (copy_dest),y
	;
	LDA raster_right,x
	LDY #$0C
	STA (copy_dest),y
	;
goto_prev_line
	LDA #$01		; check the prev byte
	JSR dec_copy_dest
	LDY #$00
	LDA (copy_dest),y
	CMP #$EA
	BEQ csv_skip_badline
	;
	LDA #25
	DB $2C
csv_skip_badline
	LDA #16
	;
dec_copy_dest
	STA dcd+1		; 16 bit sub
	LDA copy_dest
	SEC
dcd	SBC #$00
	STA copy_dest
	LDA copy_dest+1
	SBC #$00
	STA copy_dest+1 
	;
	RTS
	
;fade_out_one
;	LDX #$00
;	;
;	LDA #(raster_start+1) & 255
;	STA copy_dest
;	LDA #(raster_start+1) >> 8
;	STA copy_dest+1
;	;
;foo_loop
;	LDY #$09
;	LDA (copy_dest),y
;	LDY #$00
;	CMP #$EA		; badline
;	BEQ foo_badline
;	;
;	LDA (copy_dest),y
;	SEC
;	SBC #$10
;	STA (copy_dest),y
;	LDA #$05
;	JSR inc_copy_dest
;	;
;	LDA (copy_dest),y
;	SEC
;	SBC #$10
;	STA (copy_dest),y
;	LDA #$08
;	JSR inc_copy_dest
;	;
;	LDA (copy_dest),y
;	SEC
;	SBC #$10
;	STA (copy_dest),y
;	LDA #$05
;	JSR inc_copy_dest
;	;
;	LDA (copy_dest),y
;	SEC
;	SBC #$10
;	STA (copy_dest),y
;	LDA #$08
;	BNE foo_loop_end
;	;
;foo_badline
;	LDA (copy_dest),y
;	SEC
;	SBC #$10
;	STA (copy_dest),y
;	LDA #$05
;	JSR inc_copy_dest
;	;
;	LDA (copy_dest),y
;	SEC
;	SBC #$10
;	STA (copy_dest),y
;	LDA #$06
;	JSR inc_copy_dest
;	;
;	LDA (copy_dest),y
;	SEC
;	SBC #$10
;	STA (copy_dest),y
;	LDA #$06
;foo_loop_end
;	JSR inc_copy_dest
;	;
;	INX
;	CPX #$C8
;	BNE foo_loop
;	;
;	RTS
	
	;
	; ####################
	;	
copy_one_value
	LDX timer
	CPX #$C8
	BNE cov_1
	;
	JMP next_status
	;
cov_1	CPX #$00
	BNE cov_2
	;
	LDA #(raster_start+1) & 255
	STA copy_dest
	LDA #(raster_start+1) >> 8
	STA copy_dest+1
	;
cov_2	INC timer
	LDA raster_colors,x
	TAX
	;
	LDY #$09
	LDA (copy_dest),y
	LDY #$00
	CMP #$EA		; badline
	BEQ cov_badline
	;
	TXA
	STA (copy_dest),y
	LDA #$05
	JSR inc_copy_dest
	;
	TXA
	STA (copy_dest),y
	LDA #$08
	JSR inc_copy_dest
	;
	TXA
	STA (copy_dest),y
	LDA #$05
	JSR inc_copy_dest
	;
	TXA
	STA (copy_dest),y
	LDA #$08
	JMP inc_copy_dest
	;
cov_badline
	TXA
	STA (copy_dest),y
	LDA #$05
	JSR inc_copy_dest
	;
	TXA
	STA (copy_dest),y
	LDA #$06
	JSR inc_copy_dest
	;
	TXA
	STA (copy_dest),y
	LDA #$06
	;
inc_copy_dest
	CLC
	ADC copy_dest
	STA copy_dest
	BCC *+4
	INC copy_dest+1
	;
	RTS
	
blackout_one_line
	LDX timer
	CPX #$C8
	BNE bol_1
	;
	JMP next_status
	;
bol_1	CPX #$00
	BNE bol_2
	;
	LDA #(raster_start+1) & 255
	STA copy_dest
	LDA #(raster_start+1) >> 8
	STA copy_dest+1
	;
bol_2	INC timer
	;
	LDX #$00
	;
	LDY #$09
	LDA (copy_dest),y
	LDY #$00
	CMP #$EA		; badline
	BEQ bol_badline
	;
	TXA
	STA (copy_dest),y
	LDA #$05
	JSR inc_copy_dest
	;
	TXA
	STA (copy_dest),y
	LDA #$08
	JSR inc_copy_dest
	;
	TXA
	STA (copy_dest),y
	LDA #$05
	JSR inc_copy_dest
	;
	TXA
	STA (copy_dest),y
	LDA #$01
	JSR inc_copy_dest
	;
	LDA #$2C		; BIT $0000 opcode
	STA (copy_dest),y
	LDA #$07
	JMP inc_copy_dest
	;
bol_badline
	TXA
	STA (copy_dest),y
	LDA #$05
	JSR inc_copy_dest
	;
	TXA
	STA (copy_dest),y
	LDA #$06
	JSR inc_copy_dest
	;
	TXA
	STA (copy_dest),y
	LDA #$06
	JMP inc_copy_dest
	
	;
	; *** Raster ***
	;
	
skip21	DB $24			; spend 21 cycles
skip20	NOP			; spend 20 cycles
	NOP
	NOP
	NOP
	RTS

set_irq1	
	LDX #irq1 & 255
	LDY #irq1 >> 8
	LDA #$02
set_irq
	STX $FFFE
	STY $FFFF
	STA $FF0B
	ASL $FF09
	RTS
	
set_irq2
	LDX #irq2 & 255
	LDY #irq2 >> 8
	LDA #$CD
	BNE set_irq

irq1	STA $10
	STX $11
	STY $12
	;
	LDA $FF1E
;zz1	STA $0700
;	INC zz1+1
	;
	CMP #$36	; one cycle = HC increases by 4
	BEQ ah8		; ahead by 8
	CMP #$32
	BEQ ah4		; ahead by 4
	CMP #$2E
	BEQ ah0		; lowest value

ah8	BIT $24	; was on 56, needs $C, which is 3 cycles
ah4	BIT $24 ; was on 62
ah0	; nothing was on 6E
	;
	JSR skip20
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	;
	; -- HC: $AA, VC: $03
rscall	BIT raster_start
	;
	JSR set_irq2
	;
	LDA $10
	LDX $11
	LDY $12
	;
	RTI
	
irq2	STA $10
	STX $11
	STY $12
	;
	;DEC $FF19
	JSR PLAYER
	;
	LDX status
	LDA jumptable,x
	STA mkcall+1
	LDA jumptable+1,x
	STA mkcall+2
mkcall	JSR null
	;
	JSR set_irq1
	;INC $FF19
	;
	LDA $10
	LDX $11
	LDY $12
	;
	RTI
	
jumptable
	DW print_a,delay64,print_x,delay64,darker
	DW print_b,delay64,print_x,delay64,darker
	DW print_c,delay64,print_x,delay64,darker
	DW print_d,delay64,print_x,delay64,darker
	DW print_f,delay64
	DW show_text,delay128,darker
	DW print_p,delay64,print_chk,delay128
	;
	DW showstar
	DW null
	DW screenon
	DW delay_animate
	;
	DW showlolcat
	DW null
	DW screenon
	DW show_text
	DW delay128
	;
	DW showstar
	DW null
	DW rasterback
	DW rasterdown
	DW delay_animate
	;
	DW show_yo_dawg
	DW null
	DW screenon
	DW show_text
	DW delay128
	;
	DW showstar
	DW null
	DW rasterback
	DW splitup
	DW delay_animate
	;
	DW show_yuno
	DW null
	DW screenon
	DW show_text
	DW delay128
	;
	DW show_hat
	DW null
	DW rasterback
	DW animate_star_hat
	DW blackout_down
	;
	DW show_the_end
	DW null
	DW screenon
	DW voldown
	
null
	RTS
	
	CMAP "A",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
text_data
	DW $C00+20*40+13
	DB 11,"(NEVER MIND)"
	DW 0
	;
	DW $C00+2*40+0
	DB 0,"I"
	DW $C00+2*40+2
	DB 2,"CAN"
	DW $C00+2*40+6
	DB 2,"HAS"
	DW $C00+4*40+1
	DB 6,"RASTER?"
	DW 0
	;
	DW $C00+0*40+1
	DB 7,"YO  DAWG"
	DW $C00+2*40+2
	DB 5,"I HERD"
	DW $C00+3*40+1
	DB 7,"YOU LIKE"
	DW $C00+4*40+1
	DB 6,"RASTERS"
	DW $C00+6*40+0
	DB 9,"SO WE  PUT"
	DW $C00+7*40+1
	DB 7,"A RASTER"
	DW $C00+8*40+2
	DB 5,"IN  YO"
	DW $C00+9*40+2
	DB 5,"RASTER"
	DW $C00+11*40+0
	DB 9,"SO YOU CAN"
	DW $C00+12*40+2
	DB 5,"RASTER"
	DW $C00+13*40+1
	DB 7,"WHILE  U"
	DW $C00+14*40+2
	DB 5,"RASTER"
	DW 0
	;
	DW $C00+0*40+18
	DB 3,"PART"
	DW $C00+24*40+13
	DB 14,"Y U NO PIMPIN'?"
	DW 0
	;
	CMAP
	
open_chars
	DB $E4,$EF,$F9,$E2
	DB $78,$77,$63,$20
	
rev_chars_left
	DB $74,$61,$E7,$A0
rev_chars_right
	DB $67,$E1,$F4,$A0
	
show_text_sub
	DW st_init
	;
	DW st_openchar,st_next
	DW st_openchar,st_next
	DW st_openchar,st_next
	DW st_openchar,st_next
	DW st_openchar,st_next
	DW st_openchar,st_next
	DW st_openchar,st_next
	DW st_openchar,st_next
	;
	DW st_write,st_next,st_next
	;
	DW st_rev,st_next
	DW st_rev,st_next
	DW st_rev,st_next
	DW st_rev,st_next
	;
	DW st_rev_write
	;
	DW st_entry_done
	
next_status
	INC status
	INC status
	;
	LDA #$00
	STA timer
	;
	RTS
	
voldown
vol_delay
	LDA #$00
	CLC
	ADC #$01
	AND #$0F
	STA vol_delay+1
	BNE no_vol_down
	;
	LDA VOLUME
	CLC
	ADC #$09
	CMP #21*9
	BNE do_vol_down
	JMP $FFF6
do_vol_down
	STA VOLUME
no_vol_down
	RTS
	
darker
	LDA $FF19
	SEC
	SBC #$10
	TAX
	JSR changecolor
	JMP next_status
	
print_a
	LDA #pmp_a >> 8
	JMP print_200
	
print_b
	LDA #pmp_b >> 8
	JMP print_200
	
print_c
	LDA #pmp_c >> 8
	JMP print_200
	
print_d
	LDA #pmp_d >> 8
	JMP print_200
	
print_f
	LDA #pmp_f >> 8
	JMP print_200
	
print_p
	LDA #pmp_p >> 8
	
print_200
	STA print_src+1
	LDA #$0D    
	STA print_dst+1
	LDY #$00
	STY print_src
	STY print_dst
	;
pc1	LDA (print_src),y
	STA (print_dst),y
	INY
	LDA (print_src),y
	STA (print_dst),y
	INY
	LDA (print_src),y
	STA (print_dst),y
	INY
	LDA (print_src),y
	STA (print_dst),y
	INY
	LDA (print_src),y
	STA (print_dst),y
	INY
	LDA (print_src),y
	STA (print_dst),y
	INY
	LDA (print_src),y
	STA (print_dst),y
	INY
	LDA (print_src),y
	STA (print_dst),y
	INY
	BNE pc1
	;
	INC print_src+1
	INC print_dst+1
	;
pc2	LDA (print_src),y
	STA (print_dst),y
	INY
	LDA (print_src),y
	STA (print_dst),y
	INY
	LDA (print_src),y
	STA (print_dst),y
	INY
	LDA (print_src),y
	STA (print_dst),y
	INY
	LDA (print_src),y
	STA (print_dst),y
	INY
	LDA (print_src),y
	STA (print_dst),y
	INY
	LDA (print_src),y
	STA (print_dst),y
	INY
	LDA (print_src),y
	STA (print_dst),y
	INY
	BNE pc2
	;
	LDA #$00
pc4	STA $0900,y
	STA $0A00,y
	INY
	STA $0900,y
	STA $0A00,y
	INY
	STA $0900,y
	STA $0A00,y
	INY
	STA $0900,y
	STA $0A00,y
	INY
	BNE pc4
	;
	LDY #15
	LDA #$20
pc5	STA $0CFC,y
	STA $0F04,y
	STA $0F2C,y
	DEY
	BPL pc5
	;
	JMP next_status

print_x
	LDA #pmp_x & 255
	STA print_src
	LDA #pmp_x >> 8
	STA print_src+1
	;
	LDA #$22
	STA x_color+1
	;
	JMP print_14x14
			
print_chk
	LDA #pmp_chk & 255
	STA print_src
	LDA #pmp_chk >> 8
	STA print_src+1
	;
	LDA #$45
	STA x_color+1
	;
print_14x14
	LDA #$FD
	STA print_dst
	STA print_col
	LDA #$0C
	STA print_dst+1
	AND #$FF-4
	STA print_col+1
	;
	LDX #13
px2	LDY #13
px1	LDA (print_src),y
	CMP #$20
	BEQ sk1	
	STA (print_dst),y
x_color	LDA #$22
	STA (print_col),y
sk1	DEY
	BPL px1
	;
	LDA print_src
	CLC
	ADC #14
	STA print_src
	BCC *+4
	INC print_src+1
	;
	LDA print_dst
	CLC
	ADC #40
	STA print_dst
	STA print_col
	BCC *+6
	INC print_dst+1
	INC print_col+1
	;
	DEX
	BPL px2
	;
	JMP next_status
	
show_text
	LDX text_counter
	LDA show_text_sub,x
	STA stjump+1
	LDA show_text_sub+1,x
	STA stjump+2
stjump	JMP show_text

st_done
	LDA #$02
	JSR text_data_ptr_adv
	;
	LDA text_invert		; this is a bit of a hack...
	EOR #$80		; 1st text: no invert, 2nd text: invert; 3rd text: no invert
	STA text_invert		; so we just flip this bit between texts
	;
	JMP next_status

st_init
	LDY #$00
	LDA (text_data_ptr),y
	STA text_ptr
	INY
	LDA (text_data_ptr),y
	BEQ st_done
	;
	STA text_ptr+1
	;
	INY
	LDA (text_data_ptr),y
	STA text_length
	;
	LDA #$03
	JSR text_data_ptr_adv
	;
st_next	INC text_counter
	INC text_counter
	;
	RTS
	
st_openchar
	LDA text_counter
	LSR a
	LSR a
	TAX
	LDA open_chars,x
	EOR text_invert
	LDY text_length
	INY
	INY
stoc1	STA (text_ptr),y
	DEY
	BPL stoc1
	;
	JMP st_next
	
st_write
	LDY text_length
stw1	LDA (text_data_ptr),y
	INY
	EOR text_invert
	STA (text_ptr),y
	DEY
	DEY
	BPL stw1
	;
	JMP st_next
	
st_rev
	LDA text_counter
	LSR a
	LSR a
	SEC
	SBC #$0A
	TAX
	;
	LDA rev_chars_left,x
	EOR text_invert
	LDY #$00
	STA (text_ptr),y
	;
	LDA rev_chars_right,x
	EOR text_invert
	LDY text_length
	INY
	INY
	STA (text_ptr),y
	;
	JMP st_next
	
st_rev_write
	LDY text_length
strw1	LDA (text_data_ptr),y
	INY
	ORA #$80
	EOR text_invert
	STA (text_ptr),y
	DEY
	DEY
	BPL strw1
	;
	JMP st_next
	
st_entry_done
	LDA text_length
	CLC
	ADC #$01
	JSR text_data_ptr_adv
	; 
	LDA #$00
	STA text_counter
	;
	RTS
	
text_data_ptr_adv
	CLC
	ADC text_data_ptr
	STA text_data_ptr
	BCC *+4
	INC text_data_ptr+1
	RTS
	
splitup
	JSR animate_star
	;
su0	LDX #$00
	LDA ras_sine,x
	BEQ su1
	;
	JSR copy_split_value
	;
	LDX su0+1
	LDA ras_sine,x
	CMP #$01
	BEQ su1
	;
	JSR copy_split_value
	;
	LDX su0+1
	LDA ras_sine,x
	CMP #$02
	BEQ su1
	;
	JSR copy_split_value
	;
su1	LDX su0+1
	INX
	CPX #30
	BNE su2	    
	LDX #$00
su2	STX su0+1
	;
	RTS	

rasterdown	
	JSR animate_star
	;
rd0	LDX #$00
	LDA ras_sine,x
	BEQ rd1
	;
	JSR copy_one_value
	;
	LDX rd0+1
	LDA ras_sine,x
	CMP #$01
	BEQ rd1
	;
	JSR copy_one_value
	;
	LDX rd0+1
	LDA ras_sine,x
	CMP #$02
	BEQ rd1
	;
	JSR copy_one_value
	;
rd1	LDX rd0+1
	INX
	CPX #30
	BNE rd2	    
	LDX #$00
rd2	STX rd0+1
	;
	RTS
	
blackout_down	
	JSR animate_star
	JSR restore_hat
	;
bd0	LDX #$00
	LDA ras_sine,x
	BEQ bd1
	;
	JSR blackout_one_line
	;
	LDX bd0+1
	LDA ras_sine,x
	CMP #$01
	BEQ bd1
	;
	JSR blackout_one_line
	;
	LDX bd0+1
	LDA ras_sine,x
	CMP #$02
	BEQ bd1
	;
	JSR blackout_one_line
	;
bd1	LDX bd0+1
	INX
	CPX #30
	BNE bd2	    
	LDX #$00
bd2	STX bd0+1
	;
	RTS
	
ras_sine
	DB $00,$01,$00,$01, $01,$01,$02,$01, $02,$02,$02,$03, $02,$03,$03,$03
	DB $02,$03,$02,$02, $02,$01,$02,$01, $01,$01,$00,$01, $00,$00
	
raster_off
	LDA #$0B		; screen off
	STA $FF06
	;
	LDA $FF07
	AND #$40
	ORA #$08
	STA $FF07
	;
	LDA $FF12		; ROM font
	AND #$03
	ORA #$C4
	STA $FF12
	LDA #$D1
	STA $FF13
	;
	LDA #$2C		; BIT $0000 opcode - stop the raster call
	STA rscall
	;
	RTS
	
showlolcat
	JSR raster_off
	;
	LDA #$31		; border
	LDX #$71		; background
	JSR changecolor
	;
	LDX #lolcat_unpack & 255
	LDY #lolcat_unpack >> 8
	;
set_main
	STX main+1
	STY main+2
	;
	JMP next_status
	
show_yo_dawg
	JSR raster_off
	;
	LDA #$71
	TAX
	JSR changecolor
	;
	LDX #yo_dawg_unpack & 255
	LDY #yo_dawg_unpack >> 8
	JMP set_main
	
show_yuno
	JSR raster_off
	;
	LDA #$1E
	LDX #$71
	JSR changecolor
	;
	LDX #yuno_unpack & 255
	LDY #yuno_unpack >> 8
	JMP set_main
	
show_the_end
	JSR raster_off
	;
	LDA #$51
	LDX #$51
	JSR changecolor
	;
	LDX #the_end_unpack & 255
	LDY #the_end_unpack >> 8
	JMP set_main
		
show_hat
	LDA #$0B
	STA $FF06
	;
	LDA $FF12
	AND #$03
	STA $FF12
	;
	LDA #$2C
	STA rscall
	;
	LDX #hat_unpack & 255
	LDY #hat_unpack >> 8
	;
	JMP set_main
	
showstar
	LDA #$0B
	STA $FF06
	;
	LDA $FF12
	AND #$03
	STA $FF12
	;
	LDA #$2C
	STA rscall
	;
	LDX #prepare_star & 255
	LDY #prepare_star >> 8
	;
	JMP set_main
	
screenon
	LDA #$1B
	STA $FF06
	;
	JMP next_status
 
delay_animate
	JSR animate_star	
delay255
	INC timer
	BNE dret
	;
	JSR next_status
	;
dret	RTS

delay128
	INC timer
	INC timer
	BNE dret
	;
	JMP next_status
	
delay64
	INC timer
	INC timer
	INC timer
	INC timer
	BNE dret
	;
	JMP next_status

rasterback
	LDA #$1B
	STA $FF06
	;
	LDA #$20
	STA rscall
	;
	LDA $FF12
	AND #$03
	STA $FF12
	;
	LDA $FF07
	AND #$40
	ORA #$08
	STA $FF07
	;
	LDA #$00
	TAX
	JSR changecolor
	;
	JMP next_status
	
;sync_CC
;	LDX #$CC
;sync0	CPX $FF1D
;	BNE sync0
;	;
;	RTS
	
changecolor
	LDY #$FF
sync1	CPY $FF1D
	BNE sync1
	;
	STA $FF19
	STX $FF15
	;
	RTS
	
restore_hat	
	LDX #$05
	LDA #$01	; inv space
ash_1	STA $0E61,X
	STA $0E70,X
	STA $0E8C,X
	STA $0E96,X
	DEX
	BPL ash_1
	;
	RTS
	
animate_star_hat
	JSR animate_star
	JSR restore_hat
	;
	JMP delay255
	
animate_step
	LDX #$00		; generate the frameaddresses from screen_lo'n'font_lookup and push it into the showroutine
	;
	LDA font_lookup,x
	STA $FF13		; set the chargen.
	;
	LDA screen_lo,x
	STA $D0
	LDA screen_hi,x
	STA $D1
	;
	INX
	CPX #$0F
	BNE *+4
	LDX #$00
	STX animate_step+1
	;
	RTS
	
animate_star
	JSR animate_step
	;
star_call
	LDY #$00
	JMP code_dest
 
screen_lo
	DB screen1 & 255,screen2 & 255,screen3 & 255,screen4 & 255,screen5 & 255
	DB screen6 & 255,screen7 & 255,screen8 & 255,screen9 & 255,screenA & 255
	DB screenB & 255,screenC & 255,screenD & 255,screenE & 255,screenF & 255
	
screen_hi
	DB screen1 >> 8,screen2 >> 8,screen3 >> 8,screen4 >> 8,screen5 >> 8
	DB screen6 >> 8,screen7 >> 8,screen8 >> 8,screen9 >> 8,screenA >> 8
	DB screenB >> 8,screenC >> 8,screenD >> 8,screenE >> 8,screenF >> 8
 
font_lookup	; startaddresses, the datas of the charmatrix
	db ( font >> 8 )+$00
	db ( font >> 8 )+$04
	db ( font >> 8 )+$08
	db ( font >> 8 )+$0C
	
	db ( font >> 8 )+$10
	db ( font >> 8 )+$14
	db ( font >> 8 )+$18
	db ( font >> 8 )+$1C
	
	db ( font >> 8 )+$20
	db ( font >> 8 )+$24
	db ( font >> 8 )+$28
	db ( font >> 8 )+$2C
	
	db ( font >> 8 )+$30
	db ( font >> 8 )+$34
	db ( font >> 8 )+$38
	
scr_data
	DB 4-1,33		; 1 byte: number of chars to copy, 1 byte: number of chars to skip
	DB 10-1,28
	DB 14-1,25
	DB 16-1,23
	DB 18-1,21
	DB 20-1,19
	DB 22-1,18
	DB 8-1,6,8-1,17
	DB 8-1,8,8-1,16
	DB 7-1,10,7-1,16
	DB 6-1,12,6-1,16
	DB 6-1,12,6-1,16
	DB 6-1,12,6-1,16
	DB 6-1,12,6-1,16
	DB 6-1,12,6-1,16
	DB 7-1,10,7-1,16
	DB 8-1,8,8-1,17
	DB 8-1,6,8-1,18		; 256!
	;
	DB 22-1,19
	DB 20-1,21
	DB 18-1,23
	DB 16-1,25
	DB 14-1,28
	DB 10-1,33
	DB 4-1,1
	;
	DB 0
	
ras0	MACRO
	LDA #$00		; 22 cycles
	STA $FF15
	LDA #$00
	STA $FF19
	;
	NOP
	;  
	LDA #$00
	STA $FF19
	;
	NOP
	;
	ENDM
		
ras1	MACRO
	LDA #$00		; 65 cycles
	STA $FF15		; 4
	LDA #$00
	STA $FF19		; 4
	;
	JSR skip20
	;
	LDA #$00
	STA $FF19
	LDA #$00
	BIT $FF15		; 12
	;
	JSR skip21
	;
	ENDM
	
ras8	MACRO
	ras0			; full character line
	ras1
	ras1
	ras1
	ras1
	ras1
	ras1
	ras0
	ENDM
	
raster_start
	ras8
	ras8
	ras8
	ras8
	ras8
	;
	ras8
	ras8
	ras8
	ras8
	ras8
	;
	ras8
	ras8
	ras8
	ras8
	ras8
	;
	ras8
	ras8
	ras8
	ras8
	ras8
	;
	ras8
	ras8
	ras8
	ras8
	;
	ras0
	ras1
	ras1
	ras1
	ras1
	ras1
	ras1
raster_last_line
	ras1
	;
	LDX #$00
	STX $FF19
	STX $FF15
	;
	RTS	
	
raster_colors
	DB 0
	DB $0A,$11,$2A,$31,$1A,$21,$3A,$41
	DB $2A,$31,$4A,$51,$3A,$41,$5A,$61
	DB $4A,$51,$6A,$71,$7A,$61,$5A,$41
	DB $6A,$51,$4A,$31,$5A,$41,$3A,$21
	DB $4A,$31,$2A,$11,$3A,$21,$1A,$01
	;
	DB $0C,$11,$2C,$31,$1C,$21,$3C,$41
	DB $2C,$31,$4C,$51,$3C,$41,$5C,$61
	DB $4C,$51,$6C,$71,$7C,$61,$5C,$41
	DB $6C,$51,$4C,$31,$5C,$41,$3C,$21
	DB $4C,$31,$2C,$11,$3C,$21,$1C,$01
	;
	DB $09,$18,$29,$38,$19,$28,$39,$48
	DB $29,$38,$49,$58,$39,$48,$59,$68
	DB $49,$58,$69,$78,$79,$68,$59,$48
	DB $69,$58,$49,$38,$59,$48,$39,$28
	DB $49,$38,$29,$18,$39,$28,$19,$08
	;
	DB $03,$11,$23,$31,$13,$21,$33,$41
	DB $23,$31,$43,$51,$33,$41,$53,$61
	DB $43,$51,$63,$71,$73,$61,$53,$41
	DB $63,$51,$43,$31,$53,$41,$33,$21
	DB $43,$31,$23,$11,$33,$21,$13,$01
	;
	DB $05,$11,$25,$31,$15,$21,$35,$41
	DB $25,$31,$45,$51,$35,$41,$55,$61
	DB $45,$51,$65,$71,$75,$61,$55,$41
	DB $65,$51,$45,$31,$55,$41,$35,$21
	DB $45,$31,$25,$11,$35,$21,$15,$01
	
raster_left
	DB $03,$13,$23,$13,$23,$33,$23,$33,$43
	DB $33,$43,$53,$43,$53,$63,$53,$63,$73
	DB $73,$63,$53,$63,$53,$43,$53,$43,$33
	DB $43,$33,$23,$33,$23,$13,$23,$13,$03
	
	DB $23,$43,$63,$43,$23
	
	DB $03,$13,$23,$13,$23,$33,$23,$33,$43
	DB $33,$43,$53,$43,$53,$63,$53,$63,$73
	DB $73,$63,$53,$63,$53,$43,$53,$43,$33
	DB $43,$33,$23,$33,$23,$13,$23,$13,$03
	
	DB $23,$43,$63,$43,$23
	
	DB $03,$13,$23,$13,$23,$33,$23,$33,$43
	DB $33,$43,$53,$43,$53,$63,$53,$63,$73
	DB $73,$63,$53,$63,$53,$43,$53,$43,$33
	DB $43,$33,$23,$33,$23,$13,$23,$13,$03
	
	DB $23,$43,$63,$43,$23
	
	DB $03,$13,$23,$13,$23,$33,$23,$33,$43
	DB $33,$43,$53,$43,$53,$63,$53,$63,$73
	DB $73,$63,$53,$63,$53,$43,$53,$43,$33
	DB $43,$33,$23,$33,$23,$13,$23,$13,$03
	
	DB $23,$43,$63,$43,$23
	
	DB $03,$13,$23,$13,$23,$33,$23,$33,$43
	DB $33,$43,$53,$43,$53,$63,$53,$63,$73
	DB $73,$63,$53,$63,$53,$43,$53,$43,$33
	DB $43,$33,$23,$33,$23,$13,$23,$13,$03
	
raster_right
	DB $0C,$1C,$2C,$1C,$2C,$3C,$2C,$3C,$4C
	DB $3C,$4C,$5C,$4C,$5C,$6C,$5C,$6C,$7C
	DB $7C,$6C,$5C,$6C,$5C,$4C,$5C,$4C,$3C
	DB $4C,$3C,$2C,$3C,$2C,$1C,$2C,$1C,$0C
	
	DB $2C,$4C,$6C,$4C,$2C
	
	DB $0C,$1C,$2C,$1C,$2C,$3C,$2C,$3C,$4C
	DB $3C,$4C,$5C,$4C,$5C,$6C,$5C,$6C,$7C
	DB $7C,$6C,$5C,$6C,$5C,$4C,$5C,$4C,$3C
	DB $4C,$3C,$2C,$3C,$2C,$1C,$2C,$1C,$0C
	
	DB $2C,$4C,$6C,$4C,$2C
	
	DB $0C,$1C,$2C,$1C,$2C,$3C,$2C,$3C,$4C
	DB $3C,$4C,$5C,$4C,$5C,$6C,$5C,$6C,$7C
	DB $7C,$6C,$5C,$6C,$5C,$4C,$5C,$4C,$3C
	DB $4C,$3C,$2C,$3C,$2C,$1C,$2C,$1C,$0C
	
	DB $2C,$4C,$6C,$4C,$2C
	
	DB $0C,$1C,$2C,$1C,$2C,$3C,$2C,$3C,$4C
	DB $3C,$4C,$5C,$4C,$5C,$6C,$5C,$6C,$7C
	DB $7C,$6C,$5C,$6C,$5C,$4C,$5C,$4C,$3C
	DB $4C,$3C,$2C,$3C,$2C,$1C,$2C,$1C,$0C
	
	DB $2C,$4C,$6C,$4C,$2C 
	
	DB $0C,$1C,$2C,$1C,$2C,$3C,$2C,$3C,$4C
	DB $3C,$4C,$5C,$4C,$5C,$6C,$5C,$6C,$7C
	DB $7C,$6C,$5C,$6C,$5C,$4C,$5C,$4C,$3C
	DB $4C,$3C,$2C,$3C,$2C,$1C,$2C,$1C,$0C
	
raster_mid_left
	DB $3F,$4F,$5F,$6F,$6F,$5F,$4F,$3F
	DB $3F,$2F,$1F,$0F,$0F,$1F,$2F,$3F
	DB $3F,$4F,$5F,$6F,$6F,$5F,$4F,$3F
	DB $3F,$2F,$1F,$0F,$0F,$1F,$2F,$3F
	
	DB $3F,$4F,$5F,$6F,$6F,$5F,$4F,$3F
	DB $3F,$2F,$1F,$0F,$0F,$1F,$2F,$3F
	DB $3F,$4F,$5F,$6F,$6F,$5F,$4F,$3F
	DB $3F,$2F,$1F,$0F,$0F,$1F,$2F,$3F
	
	DB $3F,$4F,$5F,$6F,$6F,$5F,$4F,$3F
	DB $3F,$2F,$1F,$0F,$0F,$1F,$2F,$3F
	DB $3F,$4F,$5F,$6F,$6F,$5F,$4F,$3F
	DB $3F,$2F,$1F,$0F,$0F,$1F,$2F,$3F
	
	DB $3F,$4F,$5F,$6F,$6F,$5F,$4F,$3F
	DB $3F,$2F,$1F,$0F,$0F,$1F,$2F,$3F
	DB $3F,$4F,$5F,$6F,$6F,$5F,$4F,$3F
	DB $3F,$2F,$1F,$0F,$0F,$1F,$2F,$3F
	
	DB $3F,$4F,$5F,$6F,$6F,$5F,$4F,$3F
	DB $3F,$2F,$1F,$0F,$0F,$1F,$2F,$3F
	DB $3F,$4F,$5F,$6F,$6F,$5F,$4F,$3F
	DB $3F,$2F,$1F,$0F,$0F,$1F,$2F,$3F
	
	DB $3F,$4F,$5F,$6F,$6F,$5F,$4F,$3F
	DB $3F,$2F,$1F,$0F,$0F,$1F,$2F,$3F
	DB $3F,$4F,$5F,$6F,$6F,$5F,$4F,$3F
	DB $3F,$2F,$1F,$0F,$0F,$1F,$2F,$3F
	
	DB $3F,$4F,$5F,$6F,$6F,$5F,$4F,$3F
	
raster_mid_right
	DB $3A,$2A,$1A,$0A,$0A,$1A,$2A,$3A
		
	DB $3A,$4A,$5A,$6A,$6A,$5A,$4A,$3A
	DB $3A,$2A,$1A,$0A,$0A,$1A,$2A,$3A
	DB $3A,$4A,$5A,$6A,$6A,$5A,$4A,$3A
	DB $3A,$2A,$1A,$0A,$0A,$1A,$2A,$3A
	
	DB $3A,$4A,$5A,$6A,$6A,$5A,$4A,$3A
	DB $3A,$2A,$1A,$0A,$0A,$1A,$2A,$3A
	DB $3A,$4A,$5A,$6A,$6A,$5A,$4A,$3A
	DB $3A,$2A,$1A,$0A,$0A,$1A,$2A,$3A
	
	DB $3A,$4A,$5A,$6A,$6A,$5A,$4A,$3A
	DB $3A,$2A,$1A,$0A,$0A,$1A,$2A,$3A
	DB $3A,$4A,$5A,$6A,$6A,$5A,$4A,$3A
	DB $3A,$2A,$1A,$0A,$0A,$1A,$2A,$3A
	
	DB $3A,$4A,$5A,$6A,$6A,$5A,$4A,$3A
	DB $3A,$2A,$1A,$0A,$0A,$1A,$2A,$3A
	DB $3A,$4A,$5A,$6A,$6A,$5A,$4A,$3A
	DB $3A,$2A,$1A,$0A,$0A,$1A,$2A,$3A
	
	DB $3A,$4A,$5A,$6A,$6A,$5A,$4A,$3A
	DB $3A,$2A,$1A,$0A,$0A,$1A,$2A,$3A
	DB $3A,$4A,$5A,$6A,$6A,$5A,$4A,$3A
	DB $3A,$2A,$1A,$0A,$0A,$1A,$2A,$3A
	
	DB $3A,$4A,$5A,$6A,$6A,$5A,$4A,$3A
	DB $3A,$2A,$1A,$0A,$0A,$1A,$2A,$3A
	DB $3A,$4A,$5A,$6A,$6A,$5A,$4A,$3A
	DB $3A,$2A,$1A,$0A,$0A,$1A,$2A,$3A

	ALIGN $0400
font	
        include "data_font.asm"
	
	include "pmp_a_hex.asm"
	include "pmp_b_hex.asm"
	include "pmp_c_hex.asm"
	include "pmp_d_hex.asm"
	include "pmp_f_hex.asm"
	include "pmp_p_hex.asm"
	
	include "pmp_x_hex.asm"
	include "pmp_chk_hex.asm"
	
	include "screens.asm"
OFS = 0	
	include "!player.asm"
	include "!player_data.asm"
	include "music.asm"

	include "data_lolcat_packed.asm"
lolcat_packed_end
	include "data_yo_dawg_packed.asm"
yo_dawg_packed_end
	include "data_yuno_packed.asm"
yuno_packed_end
	include "data_hat_packed.asm"
hat_packed_end
	include "data_the_end_packed.asm"
the_end_packed_end
;eof